/*******************************************************************************
 *	@file			DLGraph.h
 *	@brief			DirectX Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			21-Apr-2010(Wed)
 ******************************************************************************/

#ifndef	__DLGRAPH_INCLUDE__
#define	__DLGRAPH_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

#define SetTextureColorStage( dev, i, arg1, op, arg2 )			\
		dev->SetTextureStageState( i, D3DTSS_COLOROP, op );		\
		dev->SetTextureStageState( i, D3DTSS_COLORARG1, arg1 );	\
		dev->SetTextureStageState( i, D3DTSS_COLORARG2, arg2 );

#define SetTextureAlphaStage( dev, i, arg1, op, arg2 )			\
		dev->SetTextureStageState( i, D3DTSS_ALPHAOP, op );		\
		dev->SetTextureStageState( i, D3DTSS_ALPHAARG1, arg1 );	\
		dev->SetTextureStageState( i, D3DTSS_ALPHAARG2, arg2 );

#define	FVFTEX_MAX			8

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumDraw		DLGraph.h		"DLGraph.h"
 *	@brief		`
 ******************************************************************************/
enum enumDraw
{
	enumDraw_Null			= 0,												//!< Ȃ
	enumDraw_On,																//!< `悷
	enumDraw_Off,																//!< `悵Ȃ
	enumDraw_Max,
};

/*******************************************************************************
 *	@enum		enumState		DLGraph.h		"DLGraph.h"
 *	@brief		Xe[g
 ******************************************************************************/
enum enumState
{
	enumState_Normal,															//!< ʏ
	enumState_Add,																//!< Z
	enumState_Sub,																//!< Z
	enumState_Subtract	= enumState_Sub,
	enumState_Mul,																//!< Z
	enumState_Multiply	= enumState_Mul,
	enumState_Scr,																//!< XN[
	enumState_Screen	= enumState_Scr,
	enumState_CmpD,																//!< riÁj
	enumState_Darken	= enumState_CmpD,
	enumState_CmpL,																//!< rij
	enumState_Lighten	= enumState_CmpL,
	enumState_Exc,																//!< O
	enumState_Exclusion	= enumState_Exc,

	enumState_Max,
};

/*******************************************************************************
 *	@enum		enumTex			DLGraph.h		"DLGraph.h"
 *	@brief		eNX`
 ******************************************************************************/
enum enumTex
{
	enumTex_Null			= 0,												//!< Ȃ
	enumTex_Texture,															//!< eNX`
	enumTex_File,																//!< t@C
	enumTex_Memory,																//!< 
	enumTex_Movie,																//!< [r[
	enumTex_Max,
};

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		SDLGraph		DLGraph.h		"DLGraph.h"
 *	@brief		Graphics\
 ******************************************************************************/
struct SDLGraph
{
	SDLGraph()
		: m_nWidth( 0 )
		, m_nHeight( 0 )
		, m_bMode( FALSE )
	{
	}

	//
	int						m_nWidth;											//!< 
	int						m_nHeight;											//!< 
	BOOL					m_bMode;											//!< [h
};

/*******************************************************************************
 *	@struct		D3DFVFTEX		DLGraph.h		"DLGraph.h"
 *	@brief		eNX`W\
 ******************************************************************************/
struct D3DFVFTEX
{
	float					tu;													//!< eNX`W
	float					tv;													//!< eNX`W
};

/*******************************************************************************
 *	@struct		D3DVERTEX		DLGraph.h		"DLGraph.h"
 *	@brief		_\
 ******************************************************************************/
struct D3DVERTEX
{
	float					x, y, z;											//!< ʒuW
	float					rhw;												//!< ̋t
	D3DCOLOR				color;												//!< _F
	D3DFVFTEX				tex[ FVFTEX_MAX ];									//!< eNX`W\
};

/*******************************************************************************
 *	@struct		D3DTEXTURE		DLGraph.h		"DLGraph.h"
 *	@brief		eNX`\
 ******************************************************************************/
struct D3DTEXTURE
{
	D3DTEXTURE()
		: m_lpD3DTex( NULL )
		, m_D3DDesc()

		, m_eTex( enumTex_Null )

		, m_szName()
		, m_byData( NULL )
		, m_nSize( 0 )
	{
	}

	//
	LPDIRECT3DTEXTURE9		m_lpD3DTex;											//!< eNX`
	D3DSURFACE_DESC			m_D3DDesc;											//!< \[X

	enumTex					m_eTex;												//!< eNX`tO

	LPCSTR					m_szName;											//!< O
	BYTE*					m_byData;											//!< f[^
	int						m_nSize;											//!< f[^TCY
};

/*******************************************************************************
 *	@struct		D3DFONT			DLGraph.h		"DLGraph.h"
 *	@brief		tHg\
 ******************************************************************************/
struct D3DFONT
{
	D3DFONT()
		: m_lpD3DFont( NULL )

		, m_szName()
		, m_nHeight( 0 )
	{
	}

	//
	LPD3DXFONT				m_lpD3DFont;										//!< tHg

	LPCSTR					m_szName;											//!< O
	int						m_nHeight;											//!< 
};

/*******************************************************************************
 *	@struct		D3DDATA			DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgf[^\
 ******************************************************************************/
struct D3DDATA
{
	D3DDATA()
		: m_nDataMax( 0 )
		, m_pData( NULL )
	{
	}

	//
	int						m_nDataMax;											//!< f[^
	D3DVERTEX*				m_pData;											//!< f[^
};

/*******************************************************************************
 *	@struct		D3DTEXT			DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgeLXg\
 ******************************************************************************/
struct D3DTEXT
{
	D3DTEXT()
		: m_reRect()
		, m_dwColor( 0x00000000 )
		, m_szStr()
	{
	}

	//
	RECT					m_reRect;											//!< \`
	DWORD					m_dwColor;											//!< \F

	LPSTR					m_szStr;											//!< iAhX̂݁j
};

/*******************************************************************************
 *	@struct		D3DOBJECT		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNg\
 ******************************************************************************/
struct D3DOBJECT
{
	D3DOBJECT()
		: m_bUsed( FALSE )
		, m_eObj( enumObject_Null )
		, m_nPrio( -1 )
		, m_eState( enumState_Normal )
		, m_eDraw( enumDraw_Null )
		, m_pPrev( NULL )
		, m_pNext( NULL )
	{
		for( int i = 0; i < FVFTEX_MAX; i++ )
			m_nMatNum[ i ] = -1;
	}

	// {
	BOOL					m_bUsed;											//!< gptO
	enumObject				m_eObj;												//!< IuWFNg
	int						m_nPrio;											//!< `vCIeB
	// f
	int						m_nMatNum[ FVFTEX_MAX ];							//!< fޔԍ
	// 
	enumState				m_eState;											//!< Xe[gtO
	// `
	enumDraw				m_eDraw;											//!< `tO
	// Kw\
	D3DOBJECT				*m_pPrev;											//!< O
	D3DOBJECT				*m_pNext;											//!< 

	// ėpf[^
	void*					m_pObj;												//!< ėpf[^
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@struct		CD3DTable		DLGraph.h		"DLGraph.h"
 *	@brief		e[uǗNX
 ******************************************************************************/
class CD3DTable
{
public:
	CD3DTable( int nPrio,
			   D3DOBJECT *pObj )
		: m_nPrio( nPrio )
		, m_pObj( pObj )
	{
	}

	// rZq
	bool operator<( const CD3DTable &n ) const
	{
		return m_nPrio < n.m_nPrio;
	}

	int						m_nPrio;
	D3DOBJECT				*m_pObj;
};

/*******************************************************************************
 *	@class		CDLGraph		DLGraph.h			"DLGraph.h"
 *	@brief		CDLGraphNX
 ******************************************************************************/
class CDLGraph
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:
	static const int TEXTURE_MAX	= 4096;										//!< eNX`
	static const int FONT_MAX		= 1024;										//!< tHg
	static const int OBJECT_MAX		= 65536;									//!< IuWFNg

// o֐-------------------------------------------------------------------
private:
	static int ( CDLGraph::*StepDel[ enumObject_GraphEnd - enumObject_GraphStart ] )( const int& nNum );
	static int ( CDLGraph::*StepDraw[ enumObject_GraphEnd - enumObject_GraphStart ] )( D3DOBJECT *pObj );

	BOOL SetViewPort( const int& nWidth,
					  const int& nHeight );										//!< r[|[g̐ݒ
	BOOL DeviceRestore( const HRESULT& hRes );									//!< foCX̕

	void Cleanup( void );														//!< \[X
	void Reconstruct( void );													//!< č\z

	// o^
	void EntryState( void );													//!< Xe[g̓o^

	// fލēǂݍ
	int ReloadTex( const int& nNum );											//!< eNX`ēǂݍ
	int ReloadBmp( const int& nNum );											//!< 摜ēǂݍ
	int ReloadMem( const int& nNum );											//!< ēǂݍ
	int ReloadFont( const int& nNum );											//!< tHgč쐬

	// IuWFNg폜
	int DelRect( const int& nNum );												//!< `폜
	int DelVertex( const int& nNum );											//!< ʍ폜
	int DelText( const int& nNum );												//!< eLXg폜

	// IuWFNg`
	int DrawPrimitiveUP( D3DOBJECT *pObj );										//!< v~eBu`
	int DrawText( D3DOBJECT *pObj );											//!< eLXg`

protected:
public:
	CDLGraph( void );
	~CDLGraph( void );

	void SetGraph( const SDLGraph& SGraph );									//!< ZbgAbv\̐ݒ

	int Init( const HWND& hWnd );												//!< 
	int Init( const HWND& hWnd,
			  const int& nWidth,
			  const int& nHeight,
			  const BOOL& bMode );												//!< 
	int End( void );															//!< I

	int Update( void );															//!< ʍXV

	int ChangeDisplay( const int& nPosX,
					   const int& nPosY,
					   const int& nWidth,
					   const int& nHeight,
					   const BOOL& bMode );										//!< ʐ؂ւ
	int SetDLShow( void* pDLShow );

	const LPDIRECT3D9& GetD3DObject( void ){ return m_lpD3D; }					//!< D3D IuWFNg擾
	const LPDIRECT3DDEVICE9& GetD3DDevice( void ){ return m_lpD3DDev; }			//!< D3D foCX擾

	// ڊ
	D3DTEXTURE* GetTexture( const int& nNum );									//!< eNX`擾
	D3DFONT* GetFont( const int& nNum );										//!< tHg擾
	D3DOBJECT* GetObject( const int& nNum );									//!< IuWFNg擾

	// fޓǂݍ
	int LoadTex( const LPBYTE& lpBuf,
				 const int& nSize,
				 const int& nWidth,
				 const int& nHeight );											//!< eNX`̐VK쐬
	int LoadBmp( const LPSTR& szName );											//!< 摜ǂݍ
	int LoadMem( const LPBYTE& lpBuf,
				 const int& nSize );											//!< ǂݍ
	int LoadFont( const LPSTR& szName,
				  const int& nHeight );											//!< tHg쐬

	// fމ
	int RemoveTex( const int& nNum );											//!< eNX`
	int RemoveBmp( const int& nNum );											//!< 摜
	int RemoveMem( const int& nNum );											//!< 
	int RemoveFont( const int& nNum );											//!< tHg
	int RemoveALL( void );														//!< fޑS

	// IuWFNgǉ
	int AddRect( const int& nPrio,
				 const int (&nMatNum)[ FVFTEX_MAX ],
				 const enumDraw& eDraw,
				 const enumState& eState,
				 const RECT& rcRect,
				 const int& nColor );											//!< `ǉ
	int AddVertex( const int& nPrio,
				   const int (&nMatNum)[ FVFTEX_MAX ],
				   const enumDraw& eDraw,
				   const enumState& eState,
				   const int& nVertex,
				   const D3DVERTEX* SVertex );									//!< ʒǉ
	int AddText( const int& nPrio,
				 const int (&nMatNum)[ FVFTEX_MAX ],
				 const enumDraw& eDraw,
				 const RECT& rcRect,
				 const int& nColor,
				 const LPSTR& lpStr );											//!< eLXgǉ

	// IuWFNg폜
	int Del( const int& nNum );													//!< IuWFNg폜
	int DelALL( void );															//!< IuWFNgS폜

	// Kw\
	int Connect( const int& nNum1,
				 const int& nNum2 );											//!< IuWFNgm̐ڑ
	int Disconnect( const int& nNum );											//!< IuWFNgm̐ؒf

// oϐ-------------------------------------------------------------------
private:
	LPDIRECT3D9				m_lpD3D;											//!< Direct3D IuWFNg
	LPDIRECT3DDEVICE9		m_lpD3DDev;											//!< Direct3D foCX

	void					*m_pDLShow;											//!< DirectX Show

	HWND					m_hWnd;												//!< EChEnh
	SDLGraph				m_SGraph;											//!< ZbgAbv\
	D3DPRESENT_PARAMETERS	m_D3DPP;											//!< foCX\
	D3DDISPLAYMODE			m_D3DDM;											//!< fBXvC̏
	D3DVIEWPORT9			m_D3DVP;											//!< r[|[g\

	// Xe[g
	std::vector<LPDIRECT3DSTATEBLOCK9>	m_vState;								//!< Xe[gubN

	// e[u
	std::multiset<CD3DTable>	m_vTable;										//!< `e[u

	// IuWFNg
	std::vector<D3DTEXTURE>	m_vD3DTex;											//!< eNX`\
	std::vector<D3DFONT>	m_vD3DFont;											//!< tHg\
	std::vector<D3DOBJECT>	m_vD3DObj;											//!< IuWFNg\

protected:
public:

};

// OO[oϐ-----------------------------------------------------------

// O֐vg^Cv錾-----------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLGRAPH_INCLUDE__
